package blusunrize.immersiveengineering.common.blocks.wooden;

import blusunrize.immersiveengineering.api.energy.IRotationAcceptor;
import blusunrize.immersiveengineering.common.Config.IEConfig;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IDirectionalTile;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IHasObjProperty;
import blusunrize.immersiveengineering.common.blocks.TileEntityIEBase;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumFacing.Axis;
import net.minecraft.util.ITickable;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.ArrayList;

public class TileEntityWindmill extends TileEntityIEBase implements ITickable, IDirectionalTile, IHasObjProperty
{
	public EnumFacing facing = EnumFacing.NORTH;
	public float prevRotation=0;
	public float rotation=0;
	public float turnSpeed=0;
	public float perTick = 0;

	public boolean canTurn = false;

//	@Override
//	public boolean hasFastRenderer()
//	{
//		return true;
//	}

	@Override
	public void func_73660_a()
	{
		if(field_145850_b.func_82737_E()%128==((func_174877_v().func_177958_n()^func_174877_v().func_177952_p())&127))
			canTurn = checkArea();
		if(!canTurn)
			return;

		double mod = .00005;
		if(!field_145850_b.func_72896_J())
			mod *= .75;
		if(!field_145850_b.func_72911_I())
			mod *= .66;
		if(func_174877_v().func_177956_o()>200)
			mod *= 2;
		else if(func_174877_v().func_177956_o()>150)
			mod *= 1.5;
		else if(func_174877_v().func_177956_o()>100)
			mod *= 1.25;
		else if(func_174877_v().func_177956_o()<70)
			mod *= .33;
		mod*=getSpeedModifier();
		
		
		prevRotation = (float) (turnSpeed*mod);
		rotation += turnSpeed*mod;
		rotation %= 1;
		perTick = (float) (turnSpeed*mod);

		if(!field_145850_b.field_72995_K)
		{
			TileEntity tileEntity = field_145850_b.func_175625_s(field_174879_c.func_177972_a(facing));
			if(tileEntity instanceof IRotationAcceptor)
			{
				IRotationAcceptor dynamo = (IRotationAcceptor)tileEntity;
				double power = turnSpeed*mod * 400;
				dynamo.inputRotation(Math.abs(power), facing);
			}
		}
	}
	protected float getSpeedModifier()
	{
		return .5f;
	}

	public boolean checkArea()
	{
		turnSpeed=0;
		for(int hh=-6;hh<=6;hh++)
		{
			int r=Math.abs(hh)==6?1: Math.abs(hh)==5?3: Math.abs(hh)==4?4: Math.abs(hh)>1?5: 6;
			for(int ww=-r;ww<=r;ww++)
				if((hh!=0||ww!=0)&&!field_145850_b.func_175623_d(func_174877_v().func_177982_a((facing.func_176740_k()==Axis.Z?ww:0),hh,(facing.func_176740_k()==Axis.Z?0:ww))))
					return false;
		}

		int blocked = 0;
		for(int hh=-6;hh<=6;hh++)
		{
			int r=Math.abs(hh)==6?1: Math.abs(hh)==5?3: Math.abs(hh)==4?4: Math.abs(hh)>1?5: 6;
			for(int ww=-r;ww<=r;ww++)
			{
				for(int dd=1;dd<8;dd++)
				{
					BlockPos pos = func_174877_v().func_177982_a(0, hh, 0).func_177967_a(facing.func_176734_d(), dd).func_177967_a(facing.func_176746_e(), ww);
					if(field_145850_b.func_175623_d(pos))
						turnSpeed ++;
					else if(field_145850_b.func_175625_s(pos) instanceof TileEntityWindmill)
					{
						blocked+=20;
						turnSpeed-=179;
					}
					else
						blocked++;
				}
			}
			if(blocked>100)
				return false;
		}

		return true;
	}

	@Override
	public void readCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		facing = EnumFacing.func_82600_a(nbt.func_74762_e("facing"));
		//prevRotation = nbt.getFloat("prevRotation");
		rotation = nbt.func_74760_g("rotation");
		turnSpeed = nbt.func_74760_g("turnSpeed");
	}
	@Override
	public void writeCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		nbt.func_74768_a("facing", facing.ordinal());
		//nbt.setFloat("prevRotation", prevRotation);
		nbt.func_74776_a("rotation", rotation);
		nbt.func_74776_a("turnSpeed", turnSpeed);
	}

	@SideOnly(Side.CLIENT)
	private AxisAlignedBB renderAABB;
	@SideOnly(Side.CLIENT)
	@Override
	public AxisAlignedBB getRenderBoundingBox()
	{
		if(renderAABB==null)
			renderAABB = new AxisAlignedBB(func_174877_v().func_177958_n()-(facing.func_176740_k()==Axis.Z?6:0),func_174877_v().func_177956_o()-6,func_174877_v().func_177952_p()-(facing.func_176740_k()==Axis.Z?0:6), func_174877_v().func_177958_n()+(facing.func_176740_k()==Axis.Z?7:0),func_174877_v().func_177956_o()+7,func_174877_v().func_177952_p()+(facing.func_176740_k()==Axis.Z?0:7));
		return renderAABB;
	}
	@Override
	public double func_145833_n()
	{
		return super.func_145833_n()* IEConfig.increasedTileRenderdistance;
	}
	
	@Override
	public EnumFacing getFacing()
	{
		return facing;
	}
	@Override
	public void setFacing(EnumFacing facing)
	{
		this.facing = facing;
	}
	@Override
	public int getFacingLimitation()
	{
		return 2;
	}
	@Override
	public boolean mirrorFacingOnPlacement(EntityLivingBase placer)
	{
		return false;
	}
	@Override
	public boolean canHammerRotate(EnumFacing side, float hitX, float hitY, float hitZ, EntityLivingBase entity)
	{
		return false;
	}
	@Override
	public boolean canRotate(EnumFacing axis)
	{
		return false;
	}

	static ArrayList<String> emptyDisplayList = new ArrayList();
	@Override
	public ArrayList<String> compileDisplayList()
	{
		return emptyDisplayList;
	}
}
